# Import all nesseccary Modules and Classes from PyQt5
from PyQt5.QtWidgets import QTextEdit,  QToolButton,  QFileDialog,  QLineEdit,  QLabel
import base64

# This is the main function which will be connected with the QGIS layer
def form_open( dialog, layer, featureid ):

# Define some global variables
    global name_field
    global image_field
    global image_preview
    global tool_button
    global file_name
    
        
    name_field = dialog.findChild( QLineEdit, "name" )
    file_name = dialog.findChild( QLineEdit, "filename" )
    image_field = dialog.findChild( QTextEdit, "image" )
    image_preview = dialog.findChild( QTextEdit, "imagePreview" )

# Find the QToolButton Object to connect the conversion function. 
    tool_button = dialog.findChild( QToolButton, "tool_button" )

# When the ToolButton is clicked run the method get_file_name()
    tool_button.clicked.connect(get_file_name)

# set the imageField Widget invisible for a nicer GUI. It is not nesseccary to see the data
    image_field.setVisible(False)

#Make the image preview visible with the HTML image tag

    image_preview.setText('<img width="300" src="data:image/jpg;base64,%s"/>' % (image_field.toPlainText()))


# Open FileDialog and convert the binary image to base64 
def get_file_name():
    file_path,  filter = QFileDialog.getOpenFileName(None,  'Open Image File',  '',  '(Images *.jpg *.JPG)')

    if len(file_path) > 0:        
        file_name.setText(file_path)
        encoded_image = ''
    
# Read the image file and proceed the encoding
        encoded_image = base64.b64encode(open(file_path, 'rb').read()).decode('utf-8')               

# Set the appropriate fields for storing in the QGIS layer
        image_field.setPlainText(encoded_image)
      
# Set HTML img tag around the base64 image
        image_preview.setText('<img width="400" src="data:image/jpg;base64, %s"/>' % (str(encoded_image)))
